// AUTOGENERATED - DO NOT EDIT

package client

import (
	"encoding/json"
	"fmt"

	"github.com/Arman92/go-tdlib/v2/tdlib"
)

// GetChatStatistics Returns detailed statistics about a chat. Currently this method can be used only for supergroups and channels. Can be used only if SupergroupFullInfo.can_get_statistics == true
// @param chatID Chat identifier
// @param isDark Pass true if a dark theme is used by the application
func (client *Client) GetChatStatistics(chatID int64, isDark bool) (tdlib.ChatStatistics, error) {
	result, err := client.SendAndCatch(tdlib.UpdateData{
		"@type":   "getChatStatistics",
		"chat_id": chatID,
		"is_dark": isDark,
	})

	if err != nil {
		return nil, err
	}

	if result.Data["@type"].(string) == "error" {
		return nil, tdlib.RequestError{Code: int(result.Data["code"].(float64)), Message: result.Data["message"].(string)}
	}

	switch tdlib.ChatStatisticsEnum(result.Data["@type"].(string)) {

	case tdlib.ChatStatisticsSupergroupType:
		var chatStatistics tdlib.ChatStatisticsSupergroup
		err = json.Unmarshal(result.Raw, &chatStatistics)
		return &chatStatistics, err

	case tdlib.ChatStatisticsChannelType:
		var chatStatistics tdlib.ChatStatisticsChannel
		err = json.Unmarshal(result.Raw, &chatStatistics)
		return &chatStatistics, err

	default:
		return nil, fmt.Errorf("Invalid type")
	}
}
