// AUTOGENERATED - DO NOT EDIT

package client

import (
	"encoding/json"

	"github.com/Arman92/go-tdlib/v2/tdlib"
)

// PingProxy Computes time needed to receive a response from a Telegram server through a proxy. Can be called before authorization
// @param proxyID Proxy identifier. Use 0 to ping a Telegram server without a proxy
func (client *Client) PingProxy(proxyID int32) (*tdlib.Seconds, error) {
	result, err := client.SendAndCatch(tdlib.UpdateData{
		"@type":    "pingProxy",
		"proxy_id": proxyID,
	})

	if err != nil {
		return nil, err
	}

	if result.Data["@type"].(string) == "error" {
		return nil, tdlib.RequestError{Code: int(result.Data["code"].(float64)), Message: result.Data["message"].(string)}
	}

	var seconds tdlib.Seconds
	err = json.Unmarshal(result.Raw, &seconds)
	return &seconds, err

}
